import { _decorator, Component, Label, Node } from 'cc';
import { app, JNGLayerBase } from '../../App';
import { director } from 'cc';
import GRolePVPEntity from '../../battle/base/role/PVP/GRolePVPEntity';
import { Toggle } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('HomeView')
export class HomeView extends JNGLayerBase {

    @property(Label)
    frameText:Label;

    update(){
        this.frameText.string = `当前帧数: ${app.sync.frame}`;
    }

    //设置移动
    setRoleMove(data:Toggle){
        console.log("移动",data.isChecked);
        director.getScene().getComponentsInChildren(GRolePVPEntity).forEach((role) => {
            role.input.isRun = data.isChecked;
        })
    }

    //设置攻击
    setRoleAttack(data){
        console.log("攻击",data.isChecked);
        director.getScene().getComponentsInChildren(GRolePVPEntity).forEach((role) => {
            role.input.isAttack = data.isChecked;
        })
    }

    //重置
    onClickReset(){
        app.sync.onReset();
        this.scheduleOnce(() => {
            app.sync.onStart();
        });
    }

}


